---
title: "Validate Communication Preference based on request"
url: "https://developers.zinnia.com/apis/policy-transactions-1-0-2/versions/d0006570-ab9d-464e-814f-d120ba425e84/operations/validateCommunicationPreference1"
---

> Full API specification: https://developers.zinnia.com/apis/policy-transactions-1-0-2/versions/d0006570-ab9d-464e-814f-d120ba425e84.md

# Validate Communication Preference based on request

`POST` `/policy/v1/transactions/{planCode}/{policyNumber}/parties/{partyId}/communicationpreference/validation`

Operation ID: `validateCommunicationPreference1`

## Path parameters

- `planCode` (string, required)
- `policyNumber` (string, required) - Policy Number
- `partyId` (string, required) - PartyId for which communication Preference need to be updated it be avaible under SOR Policy Details

## Request body (required)

Content types: `application/json`

## Responses

- `202` - Success
- `400` - Rules and Transaction Failure
- `500` - Unexpected error occured, please check server logs

## OpenAPI definition

```yaml
openapi: 3.1.0
info:
  title: Zinnia Policy Transactions API.
  version: 1.0.8
servers:
  - url: https://dev.api.zinnia.io
    description: DEV Environment
  - url: https://qa.api.zinnia.io
    description: QA Environment
paths:
  /policy/v1/transactions/{planCode}/{policyNumber}/parties/{partyId}/communicationpreference/validation:
    post:
      tags:
        - Non Financial Transactions
      summary: Validate Communication Preference based on request
      operationId: validateCommunicationPreference1
      parameters:
        - name: planCode
          in: path
          required: true
          schema:
            type: string
        - name: policyNumber
          in: path
          required: true
          schema:
            type: string
          description: Policy Number
        - name: partyId
          in: path
          required: true
          schema:
            type: string
          description: PartyId for which communication Preference need to be updated it be
            avaible under SOR Policy Details
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CommunicationPreferenceChangeRequest"
      responses:
        "202":
          description: Success
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransactionAcceptedResponse"
        "400":
          description: Rules and Transaction Failure
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/TransactionResponse"
              examples:
                failure:
                  $ref: "#/components/examples/failureTransactionResponse"
        "500":
          description: Unexpected error occured, please check server logs
      security:
        - Auth0: []
      x-kong-plugin-pre-function:
        config:
          access:
            - >
              local path = kong.request.get_path()

              local new_path = path:gsub("^/policy/v1/transactions",
              "/bpm/v1/policies")

              kong.service.request.set_path(new_path)
security:
  - Auth0: []
components:
  schemas:
    CommunicationPreferenceChangeRequest:
      type: object
      allOf:
        - $ref: "#/components/schemas/CommunicationPreferenceChange"
      properties:
        caseId:
          type: string
          example: CA0000007389
          description: Zinnia Live Case ID
    TransactionAcceptedResponse:
      type: object
      properties:
        correlationId:
          type: string
          example: 3a2a3435-2089-4b81-9959-e0d569ccf4f0
          description: Unique identifier which used by every system to trace the request
        caseId:
          type: string
          example: CA0000369469
          description: Zinnia Live Case ID
        caseStatus:
          type: string
          example: IN_PROGRESS
          description: Zinnia Live Case Status
        pdfId:
          type: string
          description: Identifier for the generated or associated PDF document (e.g.
            OnBase document number). Returned on systematic program setup and
            update submit when available.
          example: DOC-10004567
    TransactionResponse:
      type: object
      properties:
        status:
          type: string
          enum:
            - success
            - failure
        error:
          type: array
          items:
            $ref: "#/components/schemas/Error"
        quoteResponse:
          type: object
    CommunicationPreferenceChange:
      type: object
      properties:
        correlationId:
          type: string
          format: uuid
          example: 142f6328-0b47-412d-a1db-375e8cb81cb7
          description: The unique ID to track transaction request across all systems
        effectiveDate:
          type: string
          format: date
          pattern: ([0-9]{4})-([0-9]{2})-([0-9]{2})
          example: 2022-01-01
          description: Date (with pattern "yyyy-mm-dd")
        communicationPreference:
          type: object
          properties:
            preferredCommunicationType:
              type: string
              enum:
                - EMAIL
                - FAX
                - NOPREFERENCE
                - OTHER
                - PHONE
                - REGULARMAIL
                - TEXT
              description: Communication Preference Type
              example: EMAIL
            text:
              type: string
              example: in-person meetings or video call id https://company.us/j/1234567890
              description: If type OTHER, then provide further info using text.
          required:
            - preferredCommunicationType
      required:
        - effectiveDate
        - communicationPreference
    Error:
      type: object
      properties:
        errorCode:
          type: string
          example: BPM.NM.002
          description: This is the NIGO id generated by BPM system
        attribute:
          type: string
        error:
          type: string
          description: This is the error generated by BPM system
        resolution:
          type: string
          description: Resolution generated by BPM system to resolve the error
  examples:
    failureTransactionResponse:
      value:
        status: failure
        validationResult:
          - errorCode: BPM.NM.005
            attribute: null
            error: Amount request is invalid.
            resolution: Please check the One Time Premium Amount and submit the request
              again.
          - errorCode: BPM.NM.003
            attribute: null
            error: Party information does not match with information in the Zahara system.
            resolution: Please validate the party information and submit the request again.
  securitySchemes:
    Auth0:
      type: openIdConnect
      openIdConnectUrl: https://login.uat.zinnia.com/.well-known/openid-configuration
      x-kong-security-openid-connect:
        config:
          run_on_preflight: true
          scopes_claim:
            - https://uat.api.zinnia.io/permissions
          audience_claim:
            - aud
          audience_required:
            - https://uat.api.zinnia.io
          client_id:
            - client_id
          auth_methods:
            - bearer
        enabled: true
        protocols:
          - grpc
          - grpcs
          - http
          - https
```
